{
Ŀ
                 Joe Forster/STA                 
                                                 
                   XCTEST.PAS                    
                                                 
                     XCTest                      

}

program XCTest;

{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}

uses
  DOS;

const
{Maximum string length}
  MaxStrLen     = 255;
{Serial bus lines, converted to pin assignments on the LPT printer port; note
  the different DATA and RESET bits for the normal, extended and active
  cables}
  sbAtnNormal   = $01;
  sbClkNormal   = $02;
  sbDataNormal  = $08;
  sbDataSwapped = $04;
  sbResetNormal = $04;
  sbResetSwapped= $08;
  sbDataLines   = $0F;
  sbBidir       = $20;
{Serial bus status codes}
  ssTimeout     = $02;
  ssInputTimeout= $03;
  ssErrorMask   = $3F;
  ssEOF         = $40;
  ssNoDevice    = $80;
{Serial cables}
  scNormal      = 0;
  scExtended    = 1;
  scMultitask   = 2;
  scActive      = 3;
  scUnknown     = $80;
{LPT port modes}
  pmNone        = 0;
  pmSPP         = 1;
  pmPS2         = 2;
  pmEPP         = 3;
  pmECP         = 4;
  pmUnknown     = $80;
{File open modes}
  fmReadOnly    = 0;
  fmWriteOnly   = 1;
  fmReadWrite   = 2;
  fmModeMask    = $0F;
  fmExclusive   = $20;
  fmShared      = $40;
{Windows types}
  wtNone        = 0;
  wtWindows9x   = 1;
  wtWindowsNT   = 2;
{Display text attribute}
  TextAttr      : Byte = $07;
{Maximum number of really existing parallel ports}
  MaxRealPorts  = 3;
{Maximum number of parallel ports}
  MaxLPTPorts   = 5;
{Maximum number of states in displayed state history}
  MaxHistStates = 6;
{Maximum number of states in state history log}
  MaxLogHistStates = 255;
{Default speed of INT 08}
  DefTimerSpeed = $0000;
{PIT Timer base frequency in Hz}
  TimerBaseFreq = 1193180;
{Maximum timer frequency}
  MaxTimerFreq  = 100000;
{Minimum timer frequency}
  MinTimerFreq  = 20;
{Hexadecimal digits}
  HexaNum       : string[16] = '0123456789ABCDEF';
{Check box states}
  CheckBoxStates: array [False..True] of string[3] = ('[ ]', '[x]');
{Radio button states}
  RadioButtonStates: array [False..True] of string[3] = ('( )', '(o)');
{Line states}
  LineStates    : array [False..True] of string[4] = ('Low ', 'High');
{Frame characters}
  FrameChars    : string[9] = 'ͻ ͼ';
{Blank string to clear a line}
  BlankLine     = '                                                                               ';

type
{Port bit state}
  TState        = record
    Length      : Longint;
    State       : Boolean;
  end;
  PState        = ^TState;
{Port bit state history}
  TStateHistory = record
    EntryNum    : Integer;
    Entries     : array [0..MaxLogHistStates - 1] of TState;
  end;
{Procedure without parameters}
  TProc         = procedure;
{Function without parameters, returning a byte}
  TByteFunc     = function: Byte;
{Parallel port addresses}
  TLPTAddresses = array [0..MaxLPTPorts - 1] of Word;

var
  Compatibility,
  Interactive,
  LogicAnalyzer,
  ResetTimers,
  AtnOut,
  ClkOut,
  DataOut,
  ResetOut,
  DetectPortModes: Boolean;
  ScreenWidth,
  ScreenHeight,
  WindowsType,
  PortState,
  PrevPortState,
  LPTNum,
  Serial,
  DataBit,
  ResetBit,
  ClkDataBits,
  SerialCable   : Byte;
  CmdParPos,
  LPTAddr,
  LPTMode,
  CursorShape   : Word;
  TimerFreq     : Longint;
  TimerProc     : Pointer;
  CmdPar        : string;
  CheckTimeOut,
  AtnLo,
  AtnHi,
  ClkLo,
  ClkHi,
  DataLo,
  DataHi,
  ResetLo,
  ResetHi       : TProc;
  ReadLine      : TByteFunc;
  LPTAddresses  : TLPTAddresses;
  AtnIn,
  ClkIn,
  DataIn,
  ResetIn       : TStateHistory;
  LPTModes      : array [0..MaxLPTPorts - 1] of Byte;

procedure InitInt08; external;
procedure DoneInt08; external;
{$L XCTEST.OBJ}

{Set speed of INT 08
  Input : Speed: number of PIT cycles to wait between each interrupt}
procedure SetTimerSpeed(Speed: Word); assembler;
asm
{    cli;
    mov al, $36;
    out $43, al;
    mov ax, Speed;
    out $40, al;
    mov al, ah;
    out $40, al;
    sti;}
end;

{Convert a BCD number to binary
  Input : AX: BCD number
  Output: AX: binary number}
procedure BCDToBin; assembler;
asm
    push di;
    push bx;
    push cx;
    push dx;
    mov cx, 4;
    mov di, ax;
    xor ax, ax;
@1: mov bx, 10;
    mul bx;
    mov bx, di;
    shr bx, 12;
    add ax, bx;
    shl di, 4;
    loop @1;
    pop dx;
    pop cx;
    pop bx;
    pop di;
end;

{Restore the DOS clock from the CMOS clock}
procedure RestoreClock; assembler;
asm
   cli;
   mov ah, 2;
   int $1A;
   mov al, dh;
   xor ah, ah;
   call BCDToBin;
   mov dh, al;
   mov al, cl;
   xor ah, ah;
   call BCDToBin;
   mov cl, al;
   mov al, ch;
   xor ah, ah;
   call BCDToBin;
   mov ch, al;
   xor dl, dl;
   mov si, cx;
   mov di, dx;
   mov ah, 4;
   int $1A;
   mov al, dl;
   xor ah, ah;
   call BCDToBin;
   mov dl, al;
   mov al, dh;
   xor ah, ah;
   call BCDToBin;
   mov dh, al;
   mov ax, cx;
   call BCDToBin;
   mov cx, ax;
   mov ah, $2B;
   int $21;
   mov cx, si;
   mov dx, di;
   mov ah, $2D;
   int $21;
   sti;
end;

{Set the ATN line of the LPT port to low on a normal/extended cable}
procedure AtnLoNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, sbAtnNormal;
    or al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the ATN line of the LPT port to high on a normal/extended cable}
procedure AtnHiNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, not sbAtnNormal;
    and al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the CLK line of the LPT port to low on a normal/extended cable}
procedure ClkLoNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, sbClkNormal;
    or al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the CLK line of the LPT port to high on a normal/extended cable}
procedure ClkHiNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, not sbClkNormal;
    and al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the DATA line of the LPT port to low on a normal/extended/active cable}
procedure DataLoNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, DataBit;
    or al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the DATA line of the LPT port to high on a normal/extended/active cable}
procedure DataHiNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, DataBit;
    not al;
    and al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the RESET line of the LPT port to low on a normal/extended/active cable}
procedure ResetLoNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, ResetBit;
    not al;
    and al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Set the RESET line of the LPT port to high on a normal/extended/active cable}
procedure ResetHiNormal; far; assembler;
asm
    mov dx, LPTAddr;
    add dx, 2;
    mov al, ResetBit;
    or al, Serial;
    out dx, al;
    mov Serial, al;
end;

{Empty timeout check routine
  Output: CF: zero, no timeout has occured}
procedure TCheckTimeoutEmpty; far; assembler;
asm
    clc;
end;

{Read the status of the DATA and CLK lines of the normal cable
  Output: AL: the status of the lines
          CF: when not zero, a timeout has occured, the user pressed
              Escape or F10}
function ReadLineNormal: Byte; far; assembler;
asm
    call CheckTimeout;
    jc @2;
    mov dx, LPTAddr;
    add dx, 2;
    in al, dx;
@1: mov ah, al;
    in al, dx;
    cmp ah, al;
    jne @1;
    xor al, sbResetNormal;
    and al, sbDataLines;
    clc;
@2:
end;

{Read the status of the DATA and CLK lines of the extended cable
  Output: AL: the status of the lines
          CF: when not zero, a timeout has occured, the user pressed
              Escape or F10}
function ReadLineExtended: Byte; far; assembler;
asm
    call CheckTimeout;
    jc @2;
    mov dx, LPTAddr;
    inc dx;
    in al, dx;
@1: mov ah, al;
    in al, dx;
    cmp ah, al;
    jne @1;
    xor al, ((sbAtnNormal + sbClkNormal + sbResetNormal) shl 4);
    shr al, 4;
    mov ah, al;
    and al, sbDataLines;
    clc;
@2:
end;

{Read the status of the DATA and CLK lines of the multitask cable
  Output: AL: the status of the lines
          CF: when not zero, a timeout has occured, the user pressed
              Escape or F10}
function ReadLineMultitask: Byte; far; assembler;
asm
    call CheckTimeout;
    jc @2;
    mov dx, LPTAddr;
    inc dx;
    in al, dx;
@1: mov ah, al;
    in al, dx;
    cmp ah, al;
    jne @1;
    xor al, ((sbAtnNormal + sbClkNormal + sbDataSwapped) shl 4);
    shr al, 4;
    mov ah, al;
    and al, sbDataLines;
    clc;
@2:
end;

{Read the status of the DATA and CLK lines of the active cable
  Output: AL: the status of the lines
          CF: when not zero, a timeout has occured, the user pressed
              Escape or F10}
function ReadLineActive: Byte; far; assembler;
asm
    call CheckTimeout;
    jc @2;
    mov dx, LPTAddr;
    inc dx;
    in al, dx;
@1: mov ah, al;
    in al, dx;
    cmp ah, al;
    jne @1;
    xor al, ((sbAtnNormal + sbClkNormal + sbDataSwapped) shl 4);
    shr al, 4;
    mov ah, al;
    and al, sbDataLines;
    clc;
@2:
end;

{Determine the default parallel port control byte for a serial cable}
procedure InitSerial; assembler;
asm
    mov ah, SerialCable;
    mov al, sbDataSwapped;
    cmp ah, scMultitask;
    je @1;
    mov al, (sbAtnNormal + sbClkNormal + sbResetSwapped);
    cmp ah, scActive;
    je @1;
    mov al, sbResetNormal;
@1: mov Serial, al;
end;

{Determine if the parallel port is in the interval of valid addresses
  Input : Addr: the port address
  Output: when True, a port address is valid}
function ValidLPTAddr(Addr: Word): Boolean; assembler;
asm
    mov al, False;
    mov dx, Addr;
    cmp dx, $0200;
    jb @1;
    cmp dx, $0400;
    jae @1;
    test dx, 3;
    jne @1;
    inc al;
@1:
end;

{Reset the parallel port of a serial cable}
procedure ResetLPTPort; assembler;
asm
    push LPTAddr;
    call ValidLPTAddr;
    or al, al;
    je @1;
    mov dx, LPTAddr;
    add dx, 2;
    call InitSerial;
    mov al, Serial;
    out dx, al;
    call AtnHi;
    call ClkHi;
    call DataHi;
    call ResetHi;
    mov AtnOut, True;
    mov ClkOut, True;
    mov DataOut, True;
    mov ResetOut, True;
@1:
end;

{Initialize both parallel ports; ECP ports must be set to Byte mode, and
  all kinds of ports must be set to input mode}
procedure InitLPTPorts; assembler;
asm
    mov dx, LPTAddr;
    call @2;
    jmp @1;
@2: push dx;
    push dx;
    call ValidLPTAddr;
    pop dx;
    or al, al;
    je @3;
    add dx, 2;
    in al, dx;
    and al, not sbBidir;
    out dx, al;
    sub dx, 2;
    mov al, $FF;
    out dx, al;
    cmp DetectPortModes, False;
    je @3;
    add dx, $0402;
    mov al, $34;
    out dx, al;
    sub dx, $0400;
    in al, dx;
    or al, sbBidir;
    out dx, al;
@3: retn;
@1:
end;

{Determine the mode of an LPT port
  Input : Address: the address of the LPT port
  Output: LPT port mode}
function GetLPTMode(Address: Word): Byte; assembler;
asm
    push Address;
    call ValidLPTAddr;
    xor cl, cl;
    or al, al;
    je @1;
    mov dx, Address;
    add dx, 2;
    mov bx, dx;
    mov cl, pmECP;
    add dx, $0400;
    in al, dx;
    and al, $F8;
    mov ch, al;
    mov al, $34;
    out dx, al;
    mov dx, bx;
    mov al, $C6;
    cmp SerialCable, scExtended;
    jbe @17;
    mov al, $CA;
@17:out dx, al;
    add dx, $0400;
    in al, dx;
    cmp al, $35;
    jne @2;
    mov al, $D4;
    out dx, al;
    sub dx, 2;
    in al, dx;
    mov al, $AA;
    out dx, al;
    jmp @11;
@11:in al, dx;
    cmp al, $AA;
    jne @2;
    mov al, $55;
    out dx, al;
    jmp @12;
@12:in al, dx;
    cmp al, $55;
    jne @2;
    add dx, 2;
    mov al, $35;
    out dx, al;
    mov al, ch;
    out dx, al;
    jmp @1;
@2: mov dx, bx;
    add dx, $0400;
    mov al, ResetBit;
    cmp SerialCable, scExtended;
    jbe @18;
    or al, ch;
    jmp @19;
@18:not al;
    and al, ch;
@19:out dx, al;
    mov cl, pmEPP;
    mov al, $EF;
    call @5;
    jnc @1;
    xor al, al;
@15:push ax;
    test al, ResetBit;
    je @16;
    call @5;
    pop ax;
    jnc @1;
@16:inc al;
    jne @15;
    mov cl, pmSPP;
    mov dx, bx;
    in al, dx;
    or al, sbBidir;
    out dx, al;
    sub dx, 2;
    mov al, $AA;
    out dx, al;
    jmp @9;
@9: in al, dx;
    cmp al, $AA;
    jne @3;
    mov al, $55;
    out dx, al;
    jmp @10;
@10:in al, dx;
    cmp al, $55;
    je @13;
@3: mov cl, pmPS2;
@13:mov dx, bx;
    in al, dx;
    and al, not sbBidir;
    out dx, al;
    sub dx, 2;
    mov al, $AA;
    out dx, al;
    jmp @14;
@14:in al, dx;
    cmp al, $AA;
    jne @4;
    mov al, $55;
    out dx, al;
    jmp @8;
@8: in al, dx;
    cmp al, $55;
    je @1;
@4: xor cl, cl;
    jmp @1;
@5: mov dx, bx;
    out dx, al;
    inc dx;
    call @7;
    mov al, $AA;
    out dx, al;
    call @7;
    in al, dx;
    cmp al, $AA;
    stc;
    jne @6;
    call @7;
    mov al, $55;
    out dx, al;
    call @7;
    in al, dx;
    cmp al, $55;
    stc;
    jne @6;
    clc;
@6: retn;
@7: push ax;
    push dx;
    mov dx, bx;
    dec dx;
    in al, dx;
    or al, $01;
    out dx, al;
    and al, $FE;
    out dx, al;
    pop dx;
    pop ax;
    retn;
@1: mov dx, bx;
    mov al, ResetBit;
    out dx, al;
    mov al, cl;
end;

procedure InitWindowsType;
begin
  asm
    mov ax, $1680;
    int $2F;
    mov ah, wtNone;
    cmp al, $80;
    je @@1;
    mov ah, wtWindows9x;
@@1:mov WindowsType, ah;
  end;
  if (WindowsType <> wtNone) and (GetEnv('OS') = 'Windows_NT')
    and (GetEnv('PROCESSOR_ARCHITECTURE') = 'x86') then WindowsType := wtWindowsNT;
end;

{Enable access of the hardware ports under Windows NT/2000, using the "giveio"
  or the "userport" driver}
procedure EnableWinNTPortAccess;
var
  B             : Byte;
  I             : Integer;
  F             : file;
begin
  if WindowsType = wtWindowsNT then
  begin
    B := FileMode;
    I := InOutRes;
    FileMode := fmReadOnly;
    Assign(F, '\\.\giveio');
    Reset(F, 1);
    if IOResult = 0 then Close(F);
    Assign(F, '\\.\userport');
    Reset(F, 1);
    if IOResult = 0 then Close(F);
    InOutRes := I;
    FileMode := B;
  end;
end;

{Initialize LPT port bit variables}
procedure InitLPTBits;
begin
  DataBit := sbDataNormal;
  ResetBit := sbResetNormal;
  case SerialCable of
    scMultitask:
    begin
      DataBit := sbDataSwapped;
      ResetBit := sbResetSwapped;
    end;
    scActive:
    begin
      DataBit := sbDataSwapped;
      ResetBit := sbResetSwapped;
    end;
  end;
  ClkDataBits := DataBit or sbClkNormal;
end;

{Initialize the variables related to data transfer from or to the external
  Commodore drive}
procedure InitTransfer;
const
  ReadLines: array [scNormal..scActive] of TByteFunc = (ReadLineNormal, ReadLineExtended, ReadLineMultitask, ReadLineActive);
var
  A,
  F,
  O             : Boolean;
  B             : Byte;
begin
  LPTAddr := LPTAddresses[LPTNum];
  LPTMode := LPTModes[LPTNum];
  InitLPTBits;
  AtnLo := AtnLoNormal;
  AtnHi := AtnHiNormal;
  ClkLo := ClkLoNormal;
  ClkHi := ClkHiNormal;
  DataLo := DataLoNormal;
  DataHi := DataHiNormal;
  ResetLo := ResetLoNormal;
  ResetHi := ResetHiNormal;
  case SerialCable of
    scMultitask:
    begin
      DataLo := DataHiNormal;
      DataHi := DataLoNormal;
      ResetLo := ResetHiNormal;
      ResetHi := ResetLoNormal;
    end;
    scActive:
    begin
      AtnLo := AtnHiNormal;
      AtnHi := AtnLoNormal;
      ClkLo := ClkHiNormal;
      ClkHi := ClkLoNormal;
    end;
  end;
  ReadLine := ReadLines[SerialCable];
  AtnIn.EntryNum := 0;
  ClkIn.EntryNum := 0;
  DataIn.EntryNum := 0;
  ResetIn.EntryNum := 0;
end;

{Collect the address and mode of all parallel ports
  Input : Force: when true, the mode of all parallel ports is determined;
                 otherwise only those whose current mode is unknown}
procedure CollectLPTPorts(Force: Boolean);
var
  B             : Byte;
begin
  InitLPTBits;
  for B := 0 to MaxLPTPorts - 1 do
  begin
    if B < MaxRealPorts then LPTAddr := MemW[Seg0040:B shl 1 + 8] else LPTAddr := LPTAddresses[B];
    if (LPTAddr < $0200) or (LPTAddr >= $0400) then LPTAddr := 0;
    LPTAddresses[B] := LPTAddr;
    if DetectPortModes then
    begin
      if Force or (LPTModes[B] = pmUnknown) then LPTModes[B] := GetLPTMode(LPTAddr);
    end
    else
    begin
      if LPTModes[B] = pmNone then LPTModes[B] := pmUnknown;
    end;
  end;
end;

{Convert a long integer into a hexadecimal string
  Input : D: the long integer
          L: number of digits to put into the string
  Output: the hexadecimal string}
function HexaStr(D: Longint; L: Byte): string;
var
  I             : Byte;
  S             : string;
begin
  S := '';
  for I := L - 1 downto 0 do S := S + HexaNum[(D shr (I * 4) and $0F) + 1];
  HexaStr := S;
end;

{Convert a hexadecimal string into a long integer
  Input : S: the hexadecimal string
          Code: when not 0, an error occured
  Output: the converted long integer}
function HexaEval(const S: string; var Code: Integer): Longint;
var
  I,
  X             : Byte;
  V             : Longint;
begin
  V := 0;
  I := 1;
  Code := 0;
  while (Code = 0) and (I <= Length(S)) do
  begin
    X := Pos(UpCase(S[I]), HexaNum);
    if X = 0 then Code := I else V := V shl 4 + X - 1;
    Inc(I);
  end;
  HexaEval := V;
end;

{Return whether a key has been pressed or not}
function KeyPressed: Boolean; assembler;
asm
  mov ah, 1;
  int $16;
  mov al, False;
  je @1;
  inc al;
@1:
end;

{Read a keypress from the keyboard}
function ReadKey: Word; assembler;
asm
    xor ah, ah;
    int $16;
end;

{Clear the current screen line without line feed}
procedure ClrLine;
begin
  Write(#13, BlankLine, #13);
end;

{Input hexadecimal value
  Input : Text: prompt to display
          Str: variable to hold result
          Len: maximum length of result}
procedure AskHexaStr(const Text: string; var Str: string; Len: Integer);
var
  O             : Boolean;
  B             : Byte;
  C             : Word;
  S,
  T             : string[80];
begin
  ClrLine;
  S := Str;
  B := Length(S);
  FillChar(T, Len + 2, #8);
  O := True;
  repeat
    if O then
    begin
      O := False;
      T[0] := Chr(Length(S) - B + 1);
      Write(#13, Text, S, ' ', T);
    end;
    C := ReadKey;
    if (UpCase(Chr(C)) in ['0'..'9', 'A'..'F']) and (Length(S) < Len) then
    begin
      S := S + UpCase(Chr(C));
      Inc(B);
      O := True;
    end
    else
    begin
      case C of
        $0E08:
        begin
          if B > 0 then
          begin
            S := Copy(S, 1, B - 1) + Copy(S, B + 1, 255);
            Dec(B);
            O := True;
          end;
        end;
        $5300:
        begin
          if B < Length(S) then
          begin
            S := Copy(S, 1, B) + Copy(S, B + 2, 255);
            O := True;
          end;
        end;
        $0E7F:
        begin
          if S <> '' then
          begin
            S[0] := Chr(Len);
            FillChar(S[1], Len, ' ');
            Write(#13, Text, S);
            S := '';
            B := 0;
            O := True;
          end;
        end;
        $4B00:
        begin
          if B > 0 then
          begin
            Dec(B);
            O := True;
          end;
        end;
        $4D00:
        begin
          if B < Length(S) then
          begin
            Inc(B);
            O := True;
          end;
        end;
        $4700:
        begin
          B := 0;
          O := True;
        end;
        $4F00:
        begin
          B := Length(S);
          O := True;
        end;
        $011B:
        begin
          S := '';
          C := $1C0D;
        end;
      end;
    end;
  until C = $1C0D;
  ClrLine;
  if S <> '' then Str := S;
end;

procedure InitScreenSize; assembler;
asm
    mov ah, $0F;
    int $10;
    mov dh, ah;
    mov ax, $1130;
    xor bh, bh;
    xor dl, dl;
    int $10;
    or dl, dl;
    jne @1;
    mov dl, 24;
@1: inc dl;
    mov ScreenWidth, dh;
    mov ScreenHeight, dl;
end;

{Clear the screen}
procedure ClrScr; assembler;
asm
    mov ax, $0600;
    mov bh, TextAttr;
    xor cx, cx;
    mov dl, ScreenWidth;
    mov dh, ScreenHeight;
    dec dl;
    dec dh;
    int $10;
    mov ah, 2;
    xor bh, bh;
    xor dx, dx;
    int $10;
end;

{Go to a screen position
  Input : X, Y: row and column coordinate}
procedure GotoXY(X, Y: Byte); assembler;
asm
    mov ah, 2;
    xor bh, bh;
    mov dl, X;
    mov dh, Y;
    int $10;
end;

{Save shape of text cursor}
procedure SaveCursorShape; assembler;
asm
    mov ah, 3;
    int $10;
    mov CursorShape, cx;
end;

{Set shape of text cursor
  Input : Shape: new cursor shape}
procedure SetCursorShape(Shape: Word); assembler;
asm
    mov ah, 1;
    mov cx, Shape;
    int $10;
end;

{Restore original shape of text cursor}
procedure RestoreCursorShape;
begin
  SetCursorShape(CursorShape);
end;

{Hide text cursor}
procedure HideCursor;
begin
  SetCursorShape($2000);
end;


{Convert a string to uppercase
  Input : S: the original string
  Output: the string in uppercase}
function UpperCase(const S: string): string;
var
  I             : Integer;
  T             : string;
begin
  T[0] := Chr(Length(S));
  for I := 1 to Length(S) do T[I] := UpCase(S[I]);
  UpperCase := T;
end;

{Draw frame around item groups}
procedure DrawFrame(X, Y, V, W: Byte; const Title: string);
var
  B             : Byte;
  S             : string;
begin
  if (V >= 2) and (W >= 2) then
  begin
    FillChar(S[1], V, FrameChars[2]);
    S[1] := FrameChars[1];
    S[V] := FrameChars[3];
    S[0] := Chr(V);
    if Title <> '' then
    begin
      S[3] := ' ';
      Move(Title[1], S[4], Length(Title));
      S[4 + Length(Title)] := ' ';
    end;
    GotoXY(X, Y);
    Write(S);
    B := 1;
    while B < W - 1 do
    begin
      GotoXY(X, Y + B);
      Write(FrameChars[4]);
      GotoXY(X + (V - 1), Y + B);
      Write(FrameChars[6]);
      Inc(B);
    end;
    FillChar(S[1], V, FrameChars[8]);
    S[1] := FrameChars[7];
    S[V] := FrameChars[9];
    S[0] := Chr(V);
    GotoXY(X, Y + (W - 1));
    Write(S);
  end;
end;

{Return name of the parallel port mode
  Input : B: the parallel port number
  Output: name of the parallel port mode}
function LPTModeStr(B: Byte): string;
var
  S,
  T             : string;
begin
  T := '';
  if ValidLPTAddr(LPTAddresses[B]) and (LPTModes[B] <> pmNone) then
  begin
    T := '$' + HexaStr(LPTAddresses[B], 4);
    S := '';
    case LPTModes[B] of
      pmSPP: S := 'SPP';
      pmPS2: S := 'PS/2';
      pmEPP: S := 'EPP';
      pmECP: S := 'ECP';
      pmUnknown: S := '???';
    end;
    if S <> '' then T := T + ', ' + S;
  end;
  if T <> '' then T := ' (' + T + ') ';
  if B < MaxRealPorts then
  begin
    T := 'LPT' + Chr(B + Ord('1')) + T;
  end
  else
  begin
    T := HexaStr(LPTAddresses[B], 4) + T;
  end;
  while Length(T) < 18 do
  begin
    Inc(T[0]);
    T[Length(T)] := ' ';
  end;
  LPTModeStr := T;
end;

{Display program configuration}
procedure DisplayConfig;
var
  B,
  C             : Byte;
  S,
  T             : string;
begin
  DrawFrame(7, 3, 32, 8, 'Parallel ports');
  for B := 0 to MaxLPTPorts - 1 do
  begin
    if B < MaxRealPorts then
    begin
      S := '   ';
    end
    else
    begin
      S := '(' + Chr(B + Ord('1')) + ')';
    end;
    GotoXY(10, 4 + B);
    Write(S, '     ', LPTModeStr(B));
  end;
  GotoXY(10, 9);
  Write('(T) ', CheckBoxStates[DetectPortModes], ' Detect port modes');
  DrawFrame(41, 3, 32, 8, 'Serial cable');
  C := 4;
  for B := scNormal to scActive do
  begin
    case B of
      scNormal:
      begin
        S := '(X)';
        T := 'X1541';
      end;
      scExtended:
      begin
        S := '(E)';
        T := 'XE1541';
      end;
      scMultitask:
      begin
        S := '(M)';
        T := 'XM1541';
      end;
      scActive:
      begin
        S := '(B)';
        T := 'XA1541';
      end;
    end;
    GotoXY(44, C);
    Write(S, ' ', RadioButtonStates[(B = SerialCable)], ' ', T);
    Inc(C);
  end;
  GotoXY(44, 8);
  S := LPTModeStr(LPTNum);
  Write('(S)     ', S);
  GotoXY(44, 9);
  Write('(L) ', CheckBoxStates[LogicAnalyzer], ' Logic analyzer');
end;

{Display output pin states}
procedure DisplayLineOut;
begin
  GotoXY(6, 12);
  Write('(A) Atn: ', LineStates[AtnOut]);
  GotoXY(22, 12);
  Write('(C) Clock: ', LineStates[ClkOut]);
  GotoXY(41, 12);
  Write('(D) Data: ', LineStates[DataOut]);
  GotoXY(59, 12);
  Write('(R) Reset: ', LineStates[ResetOut]);
end;

{Update input pin state history
  Input : State: state history
          Bit: port bit}
procedure ProcessPortBit(var State: TStateHistory; Bit: Byte);
var
  O             : Boolean;
  P             : PState;
begin
  O := (PortState and Bit = 0);
  with State do
  begin
    if ResetTimers then
    begin
      Entries[0].State := (PrevPortState and Bit = 0);
      Entries[0].Length := 0;
      Entries[1].State := (PortState and Bit = 0);
      Entries[1].Length := 0;
      EntryNum := 2;
    end;
    P := @Entries[EntryNum - 1];
    if (EntryNum = 0) or (P^.State <> O) then
    begin
      if EntryNum = MaxLogHistStates then
      begin
        Move(Entries[1], Entries[0], (MaxLogHistStates - 1) * SizeOf(TState));
      end
      else
      begin
        Inc(EntryNum);
        Inc(P);
      end;
      P^.Length := 0;
      P^.State := O;
    end;
    if ResetTimers then P^.Length := 0;
    if P^.Length < 99999 then Inc(P^.Length);
  end;
end;

{Read the state of input pins}
procedure ReadLPTPort; far;
begin
  if Assigned(ReadLine) and ValidLPTAddr(LPTAddr) then
  begin
    PrevPortState := PortState;
    PortState := ReadLine;
    ProcessPortBit(AtnIn, sbAtnNormal);
    ProcessPortBit(ClkIn, sbClkNormal);
    ProcessPortBit(DataIn, DataBit);
    ProcessPortBit(ResetIn, ResetBit);
    ResetTimers := False;
  end;
end;

{Convert a long integer into a decimal string with leading zeros
  Input : L: the long integer to be converted
          N: number of digits to put into the string
  Output: the decimal string}
function LeadingZero(L: Longint; N: Word): string;
var
  I             : Word;
  S             : string;
begin
  Str(L:N, S);
  I := 1;
  while (I <= Length(S)) and (S[I] = ' ') do
  begin
    S[I] := '0';
    Inc(I);
  end;
  LeadingZero := S;
end;

{Display the frame of the input line state history box}
procedure DisplayStateHistoryFrame;
begin
  if Interactive then
  begin
    DrawFrame(1, 17, 78, 6, 'Line in history (sampled at (+/-) ' + LeadingZero(TimerFreq, 0) + ' Hz, '
      + LeadingZero(1000000 div TimerFreq, 0) + ' us)');
  end;
end;

{Initialize the timer speed}
procedure InitTimerSpeed;
var
  L             : Longint;
begin
  L := TimerBaseFreq div TimerFreq;
  if TimerBaseFreq mod TimerFreq >= TimerFreq shr 1 then Inc(L);
  if L >= $10000 then L := 0;
  DisplayStateHistoryFrame;
  SetTimerSpeed(L);
end;

{Display the state of an input pin
  Input : Y: row coordinate for display
          State: port bit state history
          Name: name of input pin}
procedure DisplayPortState(Y: Byte; State: TStateHistory; const Name: string);
var
  I,
  J,
  K             : Integer;
  S             : string;
begin
  GotoXY(4, 18 + Y);
  Write(Name, ':');
  FillChar(S[1], MaxStrLen, ' ');
  S[0] := #0;
  with State do
  begin
    if EntryNum > 0 then
    begin
      J := EntryNum - 1;
      K := J - MaxHistStates;
      if K < 0 then K := 0;
      I := J;
      while I >= K do
      begin
        if I < J then S := S + ' ';
        if Entries[I].Length = 0 then S := S + '  ... ' + LineStates[Entries[I].State] else
          S := S + LeadingZero(Entries[I].Length, 5) + '*' + LineStates[Entries[I].State];
        Dec(I);
      end;
    end;
  end;
  S[0] := #65;
  GotoXY(13, 18 + Y);
  Write(S);
end;

{Display input pin states}
procedure DisplayLineIn;
begin
  if Assigned(ReadLine) and ValidLPTAddr(LPTAddr) then
  begin
    GotoXY(10, 15);
    Write('Atn: ', LineStates[(PortState and sbAtnNormal = 0)]);
    GotoXY(26, 15);
    Write('Clock: ', LineStates[(PortState and sbClkNormal = 0)]);
    GotoXY(45, 15);
    Write('Data: ', LineStates[(PortState and DataBit = 0)]);
    GotoXY(63, 15);
    Write('Reset: ', LineStates[(PortState and ResetBit = 0)]);
    DisplayPortState(0, AtnIn, 'Atn');
    DisplayPortState(1, ClkIn, 'Clock');
    DisplayPortState(2, DataIn, 'Data');
    DisplayPortState(3, ResetIn, 'Reset');
  end;
end;

procedure TogglePortBit(var Bit: Boolean; High, Low: TProc);
begin
  if Interactive and (SerialCable <> scUnknown) and ValidLPTAddr(LPTAddr) then
  begin
    Bit := not Bit;
    ResetTimers := LogicAnalyzer;
    DisplayLineOut;
    if Bit then High else Low;
  end;
end;

{Execute options or command line parameters
  Input : C: the command character}
procedure Options(C: Char);
var
  B             : Byte;
  W             : Word;
  I             : Integer;
  L             : Longint;
  S             : string;
begin
  case C of
    'A': TogglePortBit(AtnOut, AtnHi, AtnLo);
    'C': TogglePortBit(ClkOut, ClkHi, ClkLo);
    'D': TogglePortBit(DataOut, DataHi, DataLo);
    'R': TogglePortBit(ResetOut, ResetHi, ResetLo);
    '4', '5':
    begin
      if Interactive then
      begin
        GotoXY(0, 24);
        RestoreCursorShape;
        S := '';
        AskHexaStr('Port address? ', S, 4);
        HideCursor;
      end
      else
      begin
        S := Copy(CmdPar, CmdParPos, 4);
        Inc(CmdParPos, 4);
      end;
      if S <> '' then
      begin
        B := Ord(C) -  Ord('1');
        W := HexaEval(S, I);
        if W <> LPTAddresses[B] then
        begin
          LPTAddresses[B] := W;
          LPTModes[B] := pmUnknown;
          CollectLPTPorts(True);
          LPTAddr := LPTAddresses[LPTNum];
          if Interactive then
          begin
            if SerialCable <> scUnknown then
            begin
              InitTransfer;
              InitLPTPorts;
              ResetLPTPort;
            end;
            DisplayConfig;
            if SerialCable <> scUnknown then
            begin
              DisplayLineOut;
            end;
            ResetTimers := LogicAnalyzer;
          end;
        end;
      end;
    end;
    'T':
    begin
      DetectPortModes := not DetectPortModes;
      CollectLPTPorts(True);
      if Interactive then DisplayConfig;
      ResetTimers := LogicAnalyzer;
    end;
    'B', 'E', 'M', 'X':
    begin
      case C of
        'X': B := scNormal;
        'E': B := scExtended;
        'M': B := scMultitask;
        'B': B := scActive;
      end;
      if (B <> SerialCable) then
      begin
        SerialCable := B;
        CollectLPTPorts(True);
        LPTAddr := LPTAddresses[LPTNum];
        if Interactive then
        begin
          InitTransfer;
          InitLPTPorts;
          ResetLPTPort;
          DisplayConfig;
          DisplayLineOut;
          ResetTimers := LogicAnalyzer;
        end;
      end;
    end;
    'S':
    begin
      if Interactive then
      begin
        Inc(LPTNum);
        if LPTNum >= MaxLPTPorts then LPTNum := 0;
        LPTAddr := LPTAddresses[LPTNum];
        if SerialCable <> scUnknown then
        begin
          InitTransfer;
          InitLPTPorts;
          ResetLPTPort;
          DisplayLineOut;
        end;
        DisplayConfig;
        ResetTimers := LogicAnalyzer;
      end
      else
      begin
        S := Copy(CmdPar, CmdParPos, 1);
        Inc(CmdParPos);
        Val(S, W, I);
        if (I = 0) and (W > 0) and (W <= MaxLPTPorts) then LPTNum := W - 1;
      end;
    end;
    'L':
    begin
      LogicAnalyzer := not LogicAnalyzer;
      if Interactive then DisplayConfig;
    end;
    '-':
    begin
      S := LeadingZero(TimerFreq, 0);
      if S[1] = '5' then L := (TimerFreq * 2) div 5
        else L := TimerFreq shr 1;
      if L >= MinTimerFreq then
      begin
        TimerFreq := L;
        InitTimerSpeed;
      end;
    end;
    '=', '+':
    begin
      S := LeadingZero(TimerFreq, 0);
      if S[1] = '2' then L := (TimerFreq * 5) shr 1
        else L := TimerFreq shl 1;
      if L <= MaxTimerFreq then
      begin
        TimerFreq := L;
        InitTimerSpeed;
      end;
    end;
  end;
end;

{Process a command line parameter
  Input : ParNum: parameter number; gets updated after processing
          Special: when True, process special parameters only}
procedure ProcessParameter(var ParNum: Byte; Special: Boolean);
var
  O             : Boolean;
  C             : Char;
begin
  O := True;
  CmdPar := UpperCase(ParamStr(ParNum));
  if CmdPar <> '' then
  begin
    if CmdPar[1] in ['-', '/'] then CmdPar := Copy(CmdPar, 2, MaxStrLen);
    if Special then
    begin
      if CmdPar = 'COMPAT' then Compatibility := True else
        O := False;
    end
    else
    begin
      CmdParPos := 1;
      while CmdParPos <= Length(CmdPar) do
      begin
        C := UpCase(CmdPar[CmdParPos]);
        Inc(CmdParPos);
        Options(C);
      end;
    end;
  end;
  if O then Inc(ParNum);
end;

var
  B,
  D             : Byte;
  C             : Char;
begin
  InitScreenSize;
  Interactive := False;
  DetectPortModes := False;
  Compatibility := False;
  LPTNum := 0;
  SerialCable := scUnknown;
  CheckTimeout := TCheckTimeoutEmpty;
  InitWindowsType;
  EnableWinNTPortAccess;
  CollectLPTPorts(True);
  ClrScr;
  SaveCursorShape;
  HideCursor;
  GotoXY(12, 0);
  Write('XCTest 0.13 beta - Test program for X1541-series cables');
  GotoXY(25, 1);
  Write('by Joe Forster/STA, 2001-2004');
  TimerFreq := 10000;
  TimerProc := @ReadLPTPort;
  B := 1;
  D := ParamCount;
  ProcessParameter(B, True);
  if not Compatibility then
  begin
    InitInt08;
    InitTimerSpeed;
  end;
  while B <= D do ProcessParameter(B, False);
  DisplayConfig;
  DrawFrame(3, 11, 74, 3, 'Line out');
  DrawFrame(3, 14, 74, 3, 'Line in');
  if SerialCable <> scUnknown then
  begin
    InitTransfer;
    InitLPTPorts;
    ResetLPTPort;
    DisplayLineOut;
  end;
  Interactive := True;
  DisplayStateHistoryFrame;
  C := #0;
  while C <> #27 do
  begin
    if Compatibility then ReadLPTPort;
    DisplayLineIn;
    if KeyPressed then
    begin
      C := UpCase(Chr(Lo(ReadKey)));
      Options(C);
    end;
  end;
  if not Compatibility then
  begin
    SetTimerSpeed(DefTimerSpeed);
    DoneInt08;
    RestoreClock;
  end;
  ClrScr;
  RestoreCursorShape;
end.
